//#include <stdio.h>
//#include "math.h"
#include "tc_vars.h"
//#include "hardware_t.h"
//#include "flash_t.h"
//#include "display_t.h"
//#include "floatstr_t.h"
#include "signal_t.h"
//#include "interface_t.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 							Class Signal
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/*
void Signal::Template(void)
{


}
*/

//##########################################################################################################################################################
// BF function for USTB roll mode

void Signal::USTB_Clear_Buffer(void)
{
	int lVirtual_Zero=0;
	int lChannel=0;

	USTB_Roll_idx = 0; //Set pointer to beginning

	//init buffers with ground signal
	for(lChannel = 1;lChannel <= 5;lChannel++)
	{
		switch(lChannel)
		{	
			case 1 :	//Channel 1
			{
				lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH1 / ScaleFactor[Selected_Voltage_CH1][GainIdx]);
				if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
				if (lVirtual_Zero < 0) lVirtual_Zero = 0;
				
				for(int i=0;i<1200;i++) SIGNAL1_USTB[i] = (char)lVirtual_Zero;

				break;
			}
	
			case 2 :	//Channel 2
			{
				lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH2 / ScaleFactor[Selected_Voltage_CH2][GainIdx]);
				if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
				if (lVirtual_Zero < 0) lVirtual_Zero = 0;
				
				for(int i=0;i<1200;i++) SIGNAL2_USTB[i] = (char)lVirtual_Zero;

				break;
			}

			case 3 :	//Channel 3
			{
				lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH3 / ScaleFactor[Selected_Voltage_CH3][GainIdx]);
				if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
				if (lVirtual_Zero < 0) lVirtual_Zero = 0;
				
				for(int i=0;i<1200;i++) SIGNAL3_USTB[i] = (char)lVirtual_Zero;

				break;
			}

			case 4 :	//Channel 4
			{
				lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH4 / ScaleFactor[Selected_Voltage_CH4][GainIdx]);
				if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
				if (lVirtual_Zero < 0) lVirtual_Zero = 0;
				
				for(int i=0;i<1200;i++) SIGNAL4_USTB[i] = (char)lVirtual_Zero;

				break;
			}

			case 5 :	//Channel math
			{				
				for(int i=0;i<1200;i++) SIGNALM_USTB[i] = ADC_ZERO;
				break;
			}
	
	
		}
	
	}

}
//##########################################################################################################################################################
// BF function for USTB roll mode

void Signal::USTB_roll_signal(int Time_idx, unsigned char *DataArray_in, unsigned char *Signal)
{

	int lNew_Value=0;
	int lix;

	//calculate average value of ADC data array
	for (lix = 0; lix < 128; lix++)
	{ lNew_Value += DataArray_in[lix]; }

	lNew_Value = lNew_Value >> 7;

	//write new value to the current time position
	//Signal[Time_idx] = (char)lNew_Value;

	for (lix = Time_idx; lix < 610; lix++)
	{ Signal[lix] = (char)lNew_Value; }


	
}

//##########################################################################################################################################################
// BF function for USTB shift mode

void Signal::USTB_shift_signal(unsigned char *DataArray_in, unsigned char *Signal)
{

	int lNew_Value=0;
	int lix;

	//calculate average value of ADC data array
	for (lix = 0; lix < 128; lix++)
	{ lNew_Value += DataArray_in[lix]; }

	lNew_Value = lNew_Value >> 7;
	
	//shift all value one position to the right
	for (lix = GRID_WIDTH;lix >= 0;lix--)
	{ Signal[lix+1] = Signal[lix]; }

	 //copy new value on the first position
	Signal[0] = (char)lNew_Value;

}

//##########################################################################################################################################################
/* BF */
// Build trigonometric tables for FFT
void Signal::FFT_BuildTrigoTables(void)
{
	//Speicher auf dem Stack reservieren
	int z,l,i,r,ct,buff; 	//,ar,v, la;
	int d[FFT_Level];	//Number of butterfly levels

	//Struktur vom Typ div_t erzeugen
	div_t s_div;

/*
	Signal::DRAWROUNDBUTTON(230, 180, 200, 80, 0, 0);
	Signal::TEXTOUTxvbig("Building trigonometric", 247, 192, 1, UI_Plane2);
	Signal::TEXTOUTxvbig("tables.", 247, 212, 1, UI_Plane2);
	Signal::TEXTOUTxvbig("Please wait a minute.", 247, 232, 1, UI_Plane2);
*/

/*
	// create sin() and cos() table as integer values
	for(i=0;i < FFT_Length;i++)  			
	{
		sin_tab[i] = (int)(FFT_INTFACT * sin(i*2*PI/FFT_Length));
		cos_tab[i] = (int)(FFT_INTFACT * cos(i*2*PI/FFT_Length));
	}
*/	
	// create window and trigonometric tables
	for(i=0,r=0 ;i < FFT_Length; i++)
	{
		sin_tab[i] = iSin1024[r];
		cos_tab[i] = iCos1024[r];

		win_tab[i] = FFT_Window[FFT_Windex][r];
	
		if (FFT_Length == FFT_512)
		r+=2;
		else
		r++;	
	}

	
	//Bit-Reversal- Tabelle bit_rev[0..] anlegen
	for(i=0 ;i < FFT_Length; i++)
	{
		z=i;
		//Dezimal-Index in Dualzahl umwandeln
		for(ct=0 ;ct < FFT_Level; ct++)
		{
			s_div = div(z,2);
			d[ct] = (int)s_div.rem;		// den Rest ins Feld
			z     = (int)s_div.quot;	// den Quotienten nach z
		}
		//Bit-Revers anordnen
		s_div = div(FFT_Level,2);
		for(ct=0 ;ct < (int)s_div.quot; ct++)
		{
			buff  = d[ct];
			d[ct] = d[FFT_Level-ct-1];
			d[FFT_Level-ct-1] = buff;
		}
		
		//Bit-Revers anordnen Zeitoptimiert mit Festwert
//		for(int buff,j=0;j<5;j++) 	        // 5 = FFT_LEVEL/radix  => x=div(FFT_LEVEL,2) => x.quot=5
//		{
//			buff 	     = d[j];
//			d[j] 	     = d[FFT_LEVEL-j-1];
//			d[FFT_LEVEL-j-1] = buff;
//		}

		//Umsortierten Index zurückwandeln in Dezimalzahl
		r = 0;
		for(ct=0 ;ct < FFT_Level; ct++)
		{
			r = r + (1<<ct) * d[ct];
		}
		//umsortierter Index
		bit_rev[i] = r;

	}//Ende Bit-Reversal-Tabelle
/*	
	//Delete popup
	Signal::DRAWROUNDBUTTON(230, 180, 200, 80, 0, 1);
	Signal::TEXTOUTxvbig("Building trigonometric", 247, 192, 0, UI_Plane2);
	Signal::TEXTOUTxvbig("tables.", 247, 212, 0, UI_Plane2);
	Signal::TEXTOUTxvbig("Please wait a minute.", 247, 232, 0, UI_Plane2);
*/
/*
	//check the values
	for(i=0;i < FFT_Length;i++)  			// {sin und cos-Tabelle prüfen}
	{
		//printf("SIN(x) = ");floatprintf((float)sin_tab[i]);
		//printf("COS(x) = ");floatprintf((float)cos_tab[i]);printf("\r\n");
		printf("SIN(x) =  %d\r\n",sin_tab[i]);
		printf("COS(x) =  %d\r\n",cos_tab[i]);

	}
	//check the values
//	for(Ii=0 ;Ii < FFT_LENGTH; Ii++)
//	printf("Bit reversal =  %d\r\n",bit_rev[Ii]);

*/

}

//##########################################################################################################################################################
/* BF */
// Calculate fast fourier transformation to get spectral analyzis of time signal. Trigonometric tables have to be build first.
// To get a periodic approximation, the time signal has to be processed with a window function. The simplest case is a 
// rectangle window, which has no side line suppression.
void Signal::FFT_CalcSpectrum(unsigned char *Signal, int *Spectrum)
{
	// buffer for real and imaginary part of spectrum - sharing the memory with the signal interpolation
	int *freq_re = (int *)SIGNAL1_Intpolate;   		//0x008DDD20;
	int *freq_im = (int *)SIGNAL1_Intpolate_delayed; 	//0x008DF490;
	
	//Speicher auf dem Stack reservieren
	int l=0,i=0,j=0,r=0,ar=0,v=0;
	int Fz1=0,Fz2=0,Fz3=0,Fz4=0,Fxr=0,Fxi=0,Fyr=0,Fyi=0;
	int ScaleShiftFactor;  
	

	double logval;
    	//printf("starting fft\r\n");
	
	// set variable scaling
	if (FFT_Mode == FFT_PWSP || FFT_Mode == FFT_PWDN)
	ScaleShiftFactor = FFT_Level - 3;
	else
	ScaleShiftFactor = FFT_Level - 2;


	//-----------------------------------------------
	// get time signal and make a window overlay
	//-----------------------------------------------

	//sort timevalues bitreversal
	for(i=0;i<FFT_Length;i++)
	{
		if(FFT_Windex == -1)
		freq_re[i] = (int)(Signal[bit_rev[i]] - ADC_ZERO);					// no window overlay -> rectangle
		else
		freq_re[i] =  (win_tab[bit_rev[i]] * (int)(Signal[bit_rev[i]] - ADC_ZERO)) >> 13;	// window overlay

		freq_im[i] = 0;

		//printf("freq_re[%d] = ",Ii);floatprintf(freq_re[Ii]);
		//printf("     freq_im[%d] = ",Ii);floatprintf(freq_im[Ii]);printf("\r\n");
	}

	//-----------------------------------------------
	//             calculate FFT
	//-----------------------------------------------

	//calculate complex spectral values (butterflies)
	for(l=1;(l<=FFT_Level) && !UI_request;l++)	// level loop
	{
		for(i=0;i<=((1<<(FFT_Level-l))-1) && !UI_request;i++)
		{
			for(j=0;j<=((1<<(l-1))-1);j++)
			{
				r = j + i* (1 << l);
				ar= j * (FFT_Length >> l);
				v = 1 << (l-1);
				
				Fz1 = (cos_tab[ar] * freq_re[r+v]) >> 10;	//rescale from integer conversion
				Fz2 = (cos_tab[ar] * freq_im[r+v]) >> 10;	//rescale from integer conversion
				Fz3 = (sin_tab[ar] * freq_re[r+v]) >> 10;	//rescale from integer conversion
				Fz4 = (sin_tab[ar] * freq_im[r+v]) >> 10;	//rescale from integer conversion
				Fxr = freq_re[r] + Fz1 + Fz4;
				Fxi = freq_im[r] - Fz3 + Fz2;
				Fyr = freq_re[r] - Fz1 - Fz4;
				Fyi = freq_im[r] + Fz3 - Fz2;
				freq_re[r] = Fxr;
				freq_im[r] = Fxi;
				freq_re[r+v] = Fyr;
				freq_im[r+v] = Fyi;
			}
		}
	}



	switch(FFT_Mode)
	{
		case FFT_MAGN: 	// linear magnitude
		{
			//get half of the spectrum because spectrum is mirrored at the middle and calculate output
			for (i=0,j=0;i < (FFT_Length/2)  && !UI_request;i++)
			{
				//downscale depending on FFT length
				freq_re[i] = freq_re[i] >> ScaleShiftFactor;
				freq_im[i] = freq_im[i] >> ScaleShiftFactor;

				//calc total value via power of two
				v = (freq_re[i]*freq_re[i]) + (freq_im[i]*freq_im[i]);	// v = Re² + IM²

				// and square root
				//r = iSqrt(v);
				r = Math_Sqrt(v);

				//printf("freq_re[%d] = %d    ",i,freq_re[i]);
				//printf("freq_im[%d] = %d    ",i,freq_im[i]);	
				//printf("v = Re² + IM² = %d    ",v);
				//printf("r = sqrt(v) = %d",r);
				// scale to display size
				//r = r << 2;
				//printf("scale r = %d\r\n",r);	
				
				//map to 512 or 1024 values
				if(FFT_Length == FFT_1024 )
					Spectrum[i] = r;
				else
				{ 
					Spectrum[j]   = r;
					Spectrum[j+1] = r;
					j+=2;
				}	
				
			}

			break;
		}
		
		case FFT_PHAS: 	// linear phase
		{
			//get half of the spectrum because spectrum is mirrored at the middle and calculate output
			for (i=0,j=0;i < (FFT_Length/2)  && !UI_request;i++)
			{
				//downscale depending on FFT length
				freq_re[i] = freq_re[i] >> ScaleShiftFactor;
				freq_im[i] = freq_im[i] >> ScaleShiftFactor;


				r = 10;		//BF to be done!!!!!
				//phase = arctan(imag / real)


				//map to 512 or 1024 values
				if(FFT_Length == FFT_1024 )
					Spectrum[i] = r;
				else
				{ 
					Spectrum[j]   = r;
					Spectrum[j+1] = r;
					j+=2;
				}	

			}
			break;
		}

		case FFT_REAL: 	// linear real part
		{
			//get half of the spectrum because spectrum is mirrored at the middle and calculate output
			for (i=0,j=0;i < (FFT_Length/2) && !UI_request;i++)
			{
				//map to 512 or 1024 values
				if(FFT_Length == FFT_1024 )
					Spectrum[i] = freq_re[i] >> ScaleShiftFactor;	//downscale depending on FFT length
					if (Spectrum[i] < 0)				//absolute value
					Spectrum[i] = -Spectrum[i];
			else
				{ 
					Spectrum[j]   = freq_re[i] >> ScaleShiftFactor;
					if (Spectrum[j] < 0)				//absolute value
					Spectrum[j] = -Spectrum[j];

					Spectrum[j+1] = Spectrum[j];
					j+=2;
				}	

			}
			break;
		}

		case FFT_IMAG: 	// linear imaginary part
		{
			//get half of the spectrum because spectrum is mirrored at the middle and calculate output
			for (i=0,j=0;i < (FFT_Length/2) && !UI_request;i++)
			{
				//map to 512 or 1024 values
				if(FFT_Length == FFT_1024 )
					Spectrum[i] = freq_im[i] >> ScaleShiftFactor;	//downscale depending on FFT length
					if (Spectrum[i] < 0)				//absolute value
					Spectrum[i] = -Spectrum[i];

				else
				{ 
					Spectrum[j]   = freq_im[i] >> ScaleShiftFactor;
					if (Spectrum[j] < 0)				//absolute value
					Spectrum[j] = -Spectrum[j];

					Spectrum[j+1] = Spectrum[j];
					j+=2;
				}	

			}
			
			break;
		}

		case FFT_REIM: 	// linear real + imaginary
		{
			//get half of the spectrum because spectrum is mirrored at the middle and calculate output
			for (i=0,j=0;i < (FFT_Length/2) && !UI_request;i++)
			{
				//downscale depending on FFT length
				freq_re[i] = freq_re[i] >> ScaleShiftFactor;
				freq_im[i] = freq_im[i] >> ScaleShiftFactor;
				//downscale depending on FFT length

				if (freq_re[i] < 0)				//absolute value
				freq_re[i] = -freq_re[i];
				if (freq_im[i] < 0)				//absolute value
				freq_im[i] = -freq_im[i];

				//map to 512 or 1024 values
				if(FFT_Length == FFT_1024 )
					Spectrum[i] = freq_re[i] + freq_im[i];		//add real and imaginary part
				else
				{ 
					Spectrum[j]   = freq_re[i] + freq_im[i];
					Spectrum[j+1] = Spectrum[j];
					j+=2;
				}	

			}

			
			break;
		}

		case FFT_PWSP: 	// power spectrum in dBm
		{
			//get half of the spectrum because spectrum is mirrored at the middle and calculate output
			for (i=0,j=0;i < (FFT_Length/2)  && !UI_request;i++)
			{
				//downscale depending on FFT length
				freq_re[i] = freq_re[i] >> ScaleShiftFactor;
				freq_im[i] = freq_im[i] >> ScaleShiftFactor;

				//calc total value via power of two
				v = (freq_re[i]*freq_re[i]) + (freq_im[i]*freq_im[i]);	// v = Re² + IM²
	
				// and square root
				//r = iSqrt(v);
				r = Math_Sqrt(v);			//magnitude

				// calculate power spectrum
				// ps = 20 * log10(magn / ref)		ref = 0.316 V = 323/1024
				
				r = (r * 323) >> 10;			// magn/ref
				
				r = (int)iLog10[r];			//log10(magn/ref)
			
				r = r>>1;				//downscaling

				//map to 512 or 1024 values
				if(FFT_Length == FFT_1024 )
					Spectrum[i] = r;
				else
				{ 
					Spectrum[j]   = r;
					Spectrum[j+1] = r;
					j+=2;
				}	
				
			}
			break;
		}
		case FFT_PWDN: 	// power density spectrum in dBm
		{
			//get half of the spectrum because spectrum is mirrored at the middle and calculate output
			for (i=0,j=0;i < (FFT_Length/2)  && !UI_request;i++)
			{
				//downscale depending on FFT length
				freq_re[i] = freq_re[i] >> ScaleShiftFactor;
				freq_im[i] = freq_im[i] >> ScaleShiftFactor;

				//calc total value via power of two
				v = (freq_re[i]*freq_re[i]) + (freq_im[i]*freq_im[i]);	// v = Re² + IM²
	
				// and square root
				//r = iSqrt(v);
				r = Math_Sqrt(v);			//magnitude

				// calculate power spectrum
				// ps = 20 * log10(magn / ref)		ref = 0.316 V = 323/1024
				
				r = (r * 323) >> 10;			// magn/ref
				
				r = (int)iLog10[r];			//log10(magn/ref)

				// calculate power density spectrum
				// pd = ps - 10 * log10(ENBW * df)
				r -= FFT_NormENBW; 
				
			
				//r = r>>1;				//downscaling??

				//map to 512 or 1024 values
				if(FFT_Length == FFT_1024 )
					Spectrum[i] = r;
				else
				{ 
					Spectrum[j]   = r;
					Spectrum[j+1] = r;
					j+=2;
				}	
			}
			break;
		}

	}


    	//printf("finished fft\r\n");
}

//##########################################################################################################################################################
//multiply signals
void Signal::CalcMathMul(int start, int stop, int stepwidth ,unsigned char *SignalData1, unsigned char *SignalData2, unsigned char *MathData)
{
	int lix, lfactor;
	int lbuffer, lvalue1,lvalue2;
	

	for (lix = start; lix < stop  && !UI_request; lix+=stepwidth)
	{
		//convert to signed integer
		lvalue1 = SignalData1[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH1 / ScaleFactor[Selected_Voltage_CH1][GainIdx]));
		lvalue2 = SignalData2[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH2 / ScaleFactor[Selected_Voltage_CH2][GainIdx]));

		//scale signals
		lvalue1 = lvalue1 * math_voltage_factor[Selected_Voltage_CH1];
		lvalue2 = lvalue2 * math_voltage_factor[Selected_Voltage_CH2];
		
		//and rescale
		if (lvalue1 > 0)
		lvalue1 /= math_voltage_factor[math_scale];
		else if (lvalue1 < 0)
		{lvalue1 *= -1;lvalue1 /= math_voltage_factor[math_scale]; lvalue1 *= -1;}
		
		if (lvalue2 > 0)
		lvalue2 /= math_voltage_factor[math_scale];
		else if (lvalue2 < 0)
		{lvalue2 *= -1;lvalue2 /= math_voltage_factor[math_scale]; lvalue2 *= -1;}
		
		//predivision
		lvalue1 *= predivisor[MenuStatus[1][3] - 104];
		lvalue2 *= predivisor[MenuStatus[2][3] - 104];

		//calculate math signal
		lbuffer = lvalue1 * lvalue2;
						
		//limiter
		if (lbuffer > (ADC_ZERO+1))
		{ lbuffer = (ADC_ZERO+1);}
		else if (lbuffer < -ADC_ZERO)
		{ lbuffer = -ADC_ZERO;}

		//convert to unsigned and save as char
		MathData[lix] = lbuffer + ADC_ZERO;
	
	}


}
//##########################################################################################################################################################
//subtract signals
void Signal::CalcMathSub(int start, int stop, int stepwidth ,unsigned char *SignalData1, unsigned char *SignalData2, unsigned char *MathData)
{

	int lix, lfactor;
	int lbuffer, lvalue1,lvalue2;

	for (lix = start; lix < stop  && !UI_request; lix+=stepwidth)
	{
		//convert to signed integer
		lvalue1 = SignalData1[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH1 / ScaleFactor[Selected_Voltage_CH1][GainIdx]));
		lvalue2 = SignalData2[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH2 / ScaleFactor[Selected_Voltage_CH2][GainIdx]));

		//scale signals
		lvalue1 = lvalue1 * math_voltage_factor[Selected_Voltage_CH1] * predivisor[MenuStatus[1][3] - 104];
		lvalue2 = lvalue2 * math_voltage_factor[Selected_Voltage_CH2] * predivisor[MenuStatus[2][3] - 104];
		
		//calculate math signal
		lbuffer = lvalue1 - lvalue2;
		
		//and rescale
		if (lbuffer > 0)
		lbuffer /= math_voltage_factor[math_scale];
		else if (lbuffer < 0)
		{lbuffer *= -1;lbuffer /= math_voltage_factor[math_scale]; lbuffer *= -1;}
		
		//limiter
		if (lbuffer > (ADC_ZERO+1))
		{ lbuffer = (ADC_ZERO+1);}
		else if (lbuffer < -ADC_ZERO)
		{ lbuffer = -ADC_ZERO;}
		
		//convert to unsigned and save as char
		MathData[lix] = lbuffer + ADC_ZERO;
	}


}
//##########################################################################################################################################################
//add signals
void Signal::CalcMathAdd(int start, int stop, int stepwidth ,unsigned char *SignalData1, unsigned char *SignalData2, unsigned char *MathData)
{
	int lix, lfactor;
	int lbuffer, lvalue1,lvalue2;

	for (lix = start; lix < stop  && !UI_request; lix+=stepwidth)
	//for (lix = draw_start + Trigger_Offset_Calc; lix < lstop && !UI_request; lix+=lfactor)
	{
		//convert to signed integer
		lvalue1 = SignalData1[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH1 / ScaleFactor[Selected_Voltage_CH1][GainIdx]));
		lvalue2 = SignalData2[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH2 / ScaleFactor[Selected_Voltage_CH2][GainIdx]));

		//scale signals
		lvalue1 = lvalue1 * math_voltage_factor[Selected_Voltage_CH1] * predivisor[MenuStatus[1][3] - 104];
		lvalue2 = lvalue2 * math_voltage_factor[Selected_Voltage_CH2] * predivisor[MenuStatus[2][3] - 104];
		
		//calculate math signal
		lbuffer = lvalue1 + lvalue2;

		//and rescale
		if (lbuffer > 0)
		lbuffer /= math_voltage_factor[math_scale];
		else if (lbuffer < 0)
		{ lbuffer *= -1;lbuffer /= math_voltage_factor[math_scale]; lbuffer *= -1;}
		
		//limiter
		if (lbuffer > (ADC_ZERO+1))
		{ lbuffer = (ADC_ZERO+1);}
		else if (lbuffer < -ADC_ZERO)
		{ lbuffer = -ADC_ZERO;}

		//convert to unsigned and save as char
		MathData[lix] = lbuffer + ADC_ZERO;
	}


}
//##########################################################################################################################################################
// BF Signal processing -> DSP unit
void Signal::ProcessSignalData(void)
{
	unsigned char *lPtr_S1 = NULL;	//pointer to signal 1
	unsigned char *lPtr_S2 = NULL;	//pointer to signal 2
	unsigned char *lPtr_SM = NULL;	//pointer to math signal 

	int lix, lfactor, lCalcStart, lCalcStop;
	short lIntPol_Offs = 0, lDel_IntPol_Offs = 0;


	//if (UI_request && (USTB_Mode == USTB_OFF)) return;	

	if(!ACQ_NewData) return;

//printf("calling DSP Unit \n\r");

//---------------------------------------------------------------------------------------
//		Calculate drawing parameters
//---------------------------------------------------------------------------------------
	if ((Timebase_Idx + VirtualTimebase) < 4) //BF 20ns + 10ns + 5ns + 2ns main mode - interpolated signal
	{
		draw_start = 0;
		//if (draw_start < 0) draw_start = 0;
		lIntPol_Offs = (short) MemWinStart + PreTrigComp;	//BF #003 interpolation offset 

		draw_factor = 1;
	}
	else if (FFT_Mode != FFT_OFF || USTB_Mode != USTB_OFF)
	{
		draw_start = 0;
		draw_factor = 1;
	}
	else //BF >= 50ns main mode - true signal
	{
		draw_start = (short) MemWinStart + PreTrigComp;

		if (draw_start < 0) draw_start = 0;
		
		draw_factor = (short)ZoomFactor;
	}


	if (MenuStatus[MENU_TIMEBASE][1] == 241)	//Delayed
	{
		if (ZoomFactorDel < 1) 	//20ns + 10ns delayed mode  - interpolated signal
		{
			draw_dm_ixstart  = 0;										// set to zero because whole interpolation buffer must be drawn
			draw_dm_ixfactor = (short) ZoomFactorDel;	
			lDel_IntPol_Offs = MemWinStart + PreTrigComp + (short)((float)Cursor_Delayed_1 * ZoomFactor);	//BF #003 Interpolation offset for delayed signal
		}
		else			// >= 50ns delayed mode - true signal
		{
			draw_dm_ixstart  = MemWinStart + PreTrigComp + (short)((float)Cursor_Delayed_1 * ZoomFactor);	//BF #003
			draw_dm_ixfactor = (short) ZoomFactorDel;	
		}
		lfactor = 1;	// 1 -> calculate all math values
	}	
	else //Main Mode
	{ lfactor = draw_factor; } 


	lCalcStart = MemWinStart + PreTrigComp;
	lCalcStop  = lCalcStart + (GRID_WIDTH * draw_factor) + draw_factor;



	//---------------------------------------------------------------------------------------
	//				Invert Signal
	//---------------------------------------------------------------------------------------
	if (Run)
	{
		if (Channel_1_Active && MenuStatus[MENU_CHANNEL1][2] - BTN_OFF)		// Channel 1 Invertion on?
		{
			for (int i=lCalcStart; i<lCalcStop;i++)
			{ SIGNAL1[i] = (ADC_VirtualZero_CH1<<1) - SIGNAL1[i]; }
		}
	
		if (Channel_2_Active && MenuStatus[MENU_CHANNEL2][2] - BTN_OFF)		// Channel 2 Invertion on?
		{
			for (int i=lCalcStart-draw_factor; i<lCalcStop;i++)
			{ SIGNAL2[i] = (ADC_VirtualZero_CH2<<1) - SIGNAL2[i]; }
		}
	
		if (Channel_3_Active && MenuStatus[MENU_CHANNEL3][2] - BTN_OFF)		// Channel 3 Invertion on?
		{
			for (int i=lCalcStart-draw_factor; i<lCalcStop;i++)
			{ SIGNAL3[i] = (ADC_VirtualZero_CH3<<1) - SIGNAL3[i]; }
		}
	
		if (Channel_4_Active && MenuStatus[MENU_CHANNEL4][2] - BTN_OFF)		// Channel 4 Invertion on?
		{
			for (int i=lCalcStart-draw_factor; i<lCalcStop;i++)
			{ SIGNAL4[i] = (ADC_VirtualZero_CH4<<1) - SIGNAL4[i]; }
		}
	
	}



        //--------------------------------------------------------------------------------------
	//        	 ultra slow timebase mode (roll mode / shift mode)
	//--------------------------------------------------------------------------------------
	if (USTB_NewData && !RC_request)
	{

		USTB_NewData = 0;

		//USTB refresh rate 
		switch(RealTimebase)
		{
			case 24: USTB_Refresh += (150 / (int)Channels_Active);	break;	//1S/Div
			case 25: USTB_Refresh += (300 / (int)Channels_Active);	break;	//2S/Div
			case 26: USTB_Refresh += (600 / (int)Channels_Active);	break;	//5S/Div
			case 27: USTB_Refresh += 600;	break;	//10S/Div
			case 28: USTB_Refresh += 600;	break;	//20S/Div
			case 29: USTB_Refresh += 600;	break;	//50S/Div
			case 30: USTB_Refresh += 600;	break;	//100S/Div
			case 31: USTB_Refresh += 600;	break;	//200S/Div
			case 32: USTB_Refresh += 600;	break;	//500S/Div
			case 33: USTB_Refresh += 600;	break;	//1000S/Div
		}

		//Check for time pointer overflow
		if(USTB_Roll_idx > GRID_WIDTH)
		USTB_Roll_idx = 0;


		if (USTB_Mode == USTB_ROLL)	//roll mode
		{
			if (Channel_1_Active)	
			{ USTB_roll_signal(USTB_Roll_idx, SIGNAL1, SIGNAL1_USTB); }

			if (Channel_2_Active)
			{ USTB_roll_signal(USTB_Roll_idx, SIGNAL2, SIGNAL2_USTB); }

			if (Channel_3_Active)
			{ USTB_roll_signal(USTB_Roll_idx, SIGNAL3, SIGNAL3_USTB); }

			if (Channel_4_Active)
			{ USTB_roll_signal(USTB_Roll_idx, SIGNAL4, SIGNAL4_USTB); }

			//increment time pointer
			USTB_Roll_idx ++;
		}
		else if (USTB_Mode == USTB_SHIFT)	//shift mode
		{
			if (Channel_1_Active)	
			{ USTB_shift_signal(SIGNAL1, SIGNAL1_USTB); }

			if (Channel_2_Active)
			{ USTB_shift_signal(SIGNAL2, SIGNAL2_USTB); }

			if (Channel_3_Active)
			{ USTB_shift_signal(SIGNAL3, SIGNAL3_USTB); }

			if (Channel_4_Active)
			{ USTB_shift_signal(SIGNAL4, SIGNAL4_USTB); }
		}
	
	}



	//---------------------------------------------------------------------------------------
	//				Average
	//---------------------------------------------------------------------------------------
	
	if (MenuStatus[MENU_ACQUIRE][1] > AVRG_OFF && USTB_Mode == USTB_OFF)		//Average not off?
	{
		char lmode = (char)(MenuStatus[MENU_ACQUIRE][1] - AVRG_OFF);

		if (lmode == 1)	//infinity mode
		{
			if (Channel_1_Active)
			for (int i=lCalcStart; i<lCalcStop;i++)
			{ Filter1_Buffer[i] = (unsigned char)(((int)Filter1_Buffer[i] + (int)SIGNAL1[i])>>1); 
			SIGNAL1[i] = Filter1_Buffer[i]; }

			if (Channel_2_Active)
			for (int i=lCalcStart; i<lCalcStop;i++)
			{ Filter2_Buffer[i] = (unsigned char)(((int)Filter2_Buffer[i] + (int)SIGNAL2[i])>>1); 
			SIGNAL2[i] = Filter2_Buffer[i]; }

			if (Channel_3_Active)
			for (int i=lCalcStart; i<lCalcStop;i++)
			{ Filter3_Buffer[i] = (unsigned char)(((int)Filter3_Buffer[i] + (int)SIGNAL3[i])>>1); 
			SIGNAL3[i] = Filter3_Buffer[i]; }

			if (Channel_4_Active)
			for (int i=lCalcStart; i<lCalcStop;i++)
			{ Filter4_Buffer[i] = (unsigned char)(((int)Filter4_Buffer[i] + (int)SIGNAL4[i])>>1); 
			SIGNAL4[i] = Filter4_Buffer[i]; }
		}
		else
		{
	//printf("average cnt = %d\n\r", ACQ_Average );
			if (ACQ_Average == lmode<<1)		// new cycle
			{
				if (Channel_1_Active) { for (int i=lCalcStart; i<lCalcStop;i++)	{ Filter1_Buffer[i] = SIGNAL1[i]; } }
				if (Channel_2_Active) { for (int i=lCalcStart; i<lCalcStop;i++)	{ Filter2_Buffer[i] = SIGNAL2[i]; } }
				if (Channel_3_Active) { for (int i=lCalcStart; i<lCalcStop;i++)	{ Filter3_Buffer[i] = SIGNAL3[i]; } }
				if (Channel_4_Active) { for (int i=lCalcStart; i<lCalcStop;i++)	{ Filter4_Buffer[i] = SIGNAL4[i]; } }
				
				ACQ_NewData = 0;
				ACQ_Average--;
				return;
			}
			else			// calculate average
			{ 
				for (int i=lCalcStart; i<lCalcStop;i++)
				{ Filter1_Buffer[i] =  (unsigned char)(((int)Filter1_Buffer[i] + (int)SIGNAL1[i])>>1); }
			}
			
	
			if (ACQ_Average == 0)	//cycle end
			{
				if (Channel_1_Active) { for (int i=lCalcStart; i<lCalcStop;i++) {  SIGNAL1[i] = Filter1_Buffer[i]; } }
				if (Channel_2_Active) { for (int i=lCalcStart; i<lCalcStop;i++) {  SIGNAL2[i] = Filter2_Buffer[i]; } }
				if (Channel_3_Active) { for (int i=lCalcStart; i<lCalcStop;i++) {  SIGNAL3[i] = Filter3_Buffer[i]; } }
				if (Channel_4_Active) { for (int i=lCalcStart; i<lCalcStop;i++) {  SIGNAL4[i] = Filter4_Buffer[i]; } }
	
				ACQ_Average = lmode<<1; // continous or steps
			}
			else
			{ ACQ_Average--; ACQ_NewData = 0; return;}	
		}

	}








	//---------------------------------------------------------------------------------------
	//				Noise Filter (low pass filter)
	//---------------------------------------------------------------------------------------
	
	if (MenuStatus[MENU_ACQUIRE][2] != 248)				//Noise Filter not off?
	{
		if ((USTB_Mode == USTB_OFF))// && ACQ_NewData)
		{
			//noise filter -> stage 1 nearly lossless, stage 2 with losing bandwidth
			if (MenuStatus[MENU_ACQUIRE][2] == (FILT_OFF+1) || MenuStatus[MENU_ACQUIRE][2] == (FILT_OFF+2))
			{
				char lStage = (char)(MenuStatus[MENU_ACQUIRE][2] - 248);

				if (Channel_1_Active)
				{ LowPassFilter(lCalcStart, lCalcStop, lStage, SIGNAL1, Filter1_Buffer); }
				
				if (Channel_2_Active)
				{ LowPassFilter(lCalcStart, lCalcStop, lStage, SIGNAL2, Filter2_Buffer); }
				
				if (Channel_3_Active)
				{ LowPassFilter(lCalcStart, lCalcStop, lStage, SIGNAL3, Filter3_Buffer); }
				
				if (Channel_4_Active)
				{ LowPassFilter(lCalcStart, lCalcStop, lStage, SIGNAL4, Filter4_Buffer); }
			}
			//IIR low pass filter with 1 - 3 stages
			else if (MenuStatus[MENU_ACQUIRE][2] > (FILT_OFF+2))	
			{ 
				char lStage = (char)(MenuStatus[MENU_ACQUIRE][2] - (FILT_OFF+2));

				if (Channel_1_Active)
				{ IIR_Filter(lCalcStart, lCalcStop, lStage, SIGNAL1, Filter1_Buffer); }
				
				if (Channel_2_Active)
				{ IIR_Filter(lCalcStart, lCalcStop, lStage, SIGNAL2, Filter2_Buffer); }
				
				if (Channel_3_Active)
				{ IIR_Filter(lCalcStart, lCalcStop, lStage, SIGNAL3, Filter3_Buffer); }
				
				if (Channel_4_Active)
				{ IIR_Filter(lCalcStart, lCalcStop, lStage, SIGNAL4, Filter4_Buffer); }
			}
		}

		//set signal pointers to filter buffer
		S1Ptr = Filter1_Buffer;
		S2Ptr = Filter2_Buffer;
		S3Ptr = Filter3_Buffer;
		S4Ptr = Filter4_Buffer;

//		printf("DSP filtering \n\r");

	}
	else		//no filtering
	{
		//set signal pointers to unfiltered signal
		S1Ptr = SIGNAL1;
		S2Ptr = SIGNAL2;
		S3Ptr = SIGNAL3;
		S4Ptr = SIGNAL4;
	}


        //--------------------------------------------------------------------------------------
	//        	 Interpolation (time stretch) for timebase 20ns, 10ns (5ns)
	//--------------------------------------------------------------------------------------
	if(USTB_Mode == USTB_OFF && FFT_Mode == FFT_OFF)	
	{
		if (Channel_1_Active)
		{	
			if ((Timebase_Idx + VirtualTimebase) < 4)
			{ Interpolate(Timebase_Idx+VirtualTimebase, lIntPol_Offs, S1Ptr, SIGNAL1_Intpolate); }
			
			if ((MenuStatus[MENU_TIMEBASE][1] == 241) && (ZoomFactorDel < 1)) //delayed mode
			{ Interpolate(Timebase_Idx - DelayedTimebase - 1, lDel_IntPol_Offs, S1Ptr, SIGNAL1_Intpolate_delayed); }
		}
		
		if (Channel_2_Active)
		{	
			if ((Timebase_Idx + VirtualTimebase) < 4)
			{ Interpolate(Timebase_Idx+VirtualTimebase, lIntPol_Offs, S2Ptr, SIGNAL2_Intpolate); }
			
			if ((MenuStatus[MENU_TIMEBASE][1] == 241) && (ZoomFactorDel < 1))	//delayed mode
			{ Interpolate(Timebase_Idx - DelayedTimebase - 1, lDel_IntPol_Offs, S2Ptr, SIGNAL2_Intpolate_delayed); }
		}	
		//4-Channel Version
		if (NumberOfChannels == 4)
		{	
			if (Channel_3_Active)
			{	
				if ((Timebase_Idx + VirtualTimebase) < 4)
				{ Interpolate(Timebase_Idx+VirtualTimebase, lIntPol_Offs, S3Ptr, SIGNAL3_Intpolate); }
				
				if ((MenuStatus[MENU_TIMEBASE][1] == 241) && (ZoomFactorDel < 1))	//delayed mode
				{ Interpolate(Timebase_Idx - DelayedTimebase - 1, lDel_IntPol_Offs, S3Ptr, SIGNAL3_Intpolate_delayed); }
			}	
			
			if (Channel_4_Active)
			{		   	
				if ((Timebase_Idx + VirtualTimebase) < 4)
				{ Interpolate(Timebase_Idx+VirtualTimebase, lIntPol_Offs, S4Ptr, SIGNAL4_Intpolate); }
				
				if ((MenuStatus[MENU_TIMEBASE][1] == 241) && (ZoomFactorDel < 1))	//delayed mode
				{ Interpolate(Timebase_Idx - DelayedTimebase - 1, lDel_IntPol_Offs, S4Ptr, SIGNAL4_Intpolate_delayed); }
			}
		}	

	}
	


	//---------------------------------------------------------------------------------------
	//				MATH functions
	//---------------------------------------------------------------------------------------
	
	if (Channel_Math_Active) 
	{

		//---------------------------------------------
		//         MATH function FFT
		//---------------------------------------------
		if (FFT_Mode != FFT_OFF)               	// fft
		{
			//if(FFT_NewData || !Run)	// BF calculate spectrum
			if(FFT_NewData)		//BF test!!!!!!!!!!!
			{ 
				if(Channel_1_Active) FFT_CalcSpectrum(SIGNAL1,SPECTRUM);
				else if(Channel_2_Active) FFT_CalcSpectrum(SIGNAL2,SPECTRUM);
				else if(Channel_3_Active) FFT_CalcSpectrum(SIGNAL3,SPECTRUM);
				else if(Channel_4_Active) FFT_CalcSpectrum(SIGNAL4,SPECTRUM);
			}	
			
			return;
		}	

		//width of calculating for math functions
//		lcalcstop = draw_start + ((GRID_WIDTH + 30) * draw_factor);	//BF ????? can be optimized!!
//		if (lcalcstop > 16280){lcalcstop = 16280;}
	
	
		//set pointers to signals
		if ((Timebase_Idx + VirtualTimebase) < 4) //BF 20ns + 10ns + 5ns + 2ns main mode - interpolated signal
		{
			lPtr_S1 = SIGNAL1_Intpolate;
			lPtr_S2 = SIGNAL2_Intpolate;
			lPtr_SM = SIGNALM_Intpolate;
		}
		else
		{
			lPtr_S1 = S1Ptr;
			lPtr_S2 = S2Ptr;
			lPtr_SM = SIGNALM;
		}
		


		//---------------------------------------------
		//         MATH function multiply
		//---------------------------------------------
		if ((MenuStatus[MENU_MATH][2] == 241) && (Channel_1_Active && Channel_2_Active))      		// multiply 
		{	
			//set global math scaling and offset for drawing routine
			math_scale = math_mul_scale - 166;
			Math_Offset = Math_Mul_Offset;
			
			//calculate main math signal
			CalcMathMul(draw_start, lCalcStop, lfactor, lPtr_S1, lPtr_S2, lPtr_SM);
			
			//calculate delayed math signal
			if ((MenuStatus[MENU_TIMEBASE][1] == 241) && ((Timebase_Idx - DelayedTimebase -1) < 4))	//BF #003
			{ CalcMathMul(0, GRID_WIDTH+1, 1, SIGNAL1_Intpolate_delayed, SIGNAL2_Intpolate_delayed, SIGNALM_Intpolate_delayed); }
		}	//multiply end

		//---------------------------------------------
		//         MATH function subtract
		//---------------------------------------------

		else if ((MenuStatus[MENU_MATH][3] == 241) && (Channel_1_Active && Channel_2_Active))            	// subtract
		{	
			//set global math scaling and offset for drawing routine
			math_scale = math_sub_scale - 150;
			Math_Offset = Math_Sub_Offset;
			
			//calculate main math signal
			CalcMathSub(draw_start, lCalcStop, lfactor, lPtr_S1, lPtr_S2, lPtr_SM);

			//calculate delayed math signal
			if ((MenuStatus[MENU_TIMEBASE][1] == 241) && ((Timebase_Idx - DelayedTimebase -1) < 4))	//BF #003
			{ CalcMathSub(0, GRID_WIDTH+1, 1, SIGNAL1_Intpolate_delayed, SIGNAL2_Intpolate_delayed, SIGNALM_Intpolate_delayed); }
		}	//subtract end

		//---------------------------------------------
		//         MATH function add
		//---------------------------------------------
		else if ((MenuStatus[MENU_MATH][4] == 241) && (Channel_1_Active && Channel_2_Active))            	// add
		{
			//set global math scaling and offset for drawing routine
			math_scale = math_add_scale - 150;
			Math_Offset = Math_Add_Offset;
			
			//calculate main math signal
			CalcMathAdd(draw_start, lCalcStop, lfactor, lPtr_S1, lPtr_S2, lPtr_SM);

			//calculate delayed math signal
			if ((MenuStatus[MENU_TIMEBASE][1] == 241) && ((Timebase_Idx - DelayedTimebase -1) < 4))	//BF #003
			{ CalcMathAdd(0, GRID_WIDTH+1, 1, SIGNAL1_Intpolate_delayed, SIGNAL2_Intpolate_delayed, SIGNALM_Intpolate_delayed); }
		}	//add end
		else if (!Channel_1_Active && Channel_2_Active)
		{
			for(int i=0;i<16280;i++) SIGNALM[i] = ADC_ZERO;			//SIGNAL2[i];
			for(int i=0;i<1199;i++) SIGNALM_Intpolate[i] = ADC_ZERO;	//SIGNAL2_Intpolate[i];
		}
		else if (!Channel_2_Active && Channel_1_Active)
		{
			for(int i=0;i<16280;i++) SIGNALM[i] = ADC_ZERO;			//SIGNAL1[i];
			for(int i=0;i<1199;i++) SIGNALM_Intpolate[i] = ADC_ZERO;	//SIGNAL1_Intpolate[i];
		}
		
		

	}//Math End


} //Signal processing end 
//##########################################################################################################################################################
// BF Timebase 50ns is the fastest real timebase. For timebase 20nS, 10nS, 5nS and 2nS the additional samples must be interpolated 
// BF replaced complete interpolation with a simplified routine
// BF new linear interpolation
void Signal::Interpolate(int timebase, int start, unsigned char *SignalData, unsigned char *InterpolateResult)
{
    int ix,iy,incr;
	
	if (UI_request) return;	

	//printf("\r\ninterpolation start %d\r\n", start);	

	if(!test_sw2)
	{
		//printf("Linear interpolation on TB %d\r\n", timebase);

		if (timebase == 0)		// 2ns 
		{
			for(ix=0,iy=start;ix < (GRID_WIDTH + 25);ix+=25,iy++)
			LinearInterpolation(ix, (int)SignalData[iy], ix + 25, (int)SignalData[iy+1], InterpolateResult);
		}
		else if (timebase == 1)		// 5ns 
		{
			for(ix=0,iy=start;ix < (GRID_WIDTH + 10);ix+=10,iy++)
			LinearInterpolation(ix, (int)SignalData[iy], ix + 10, (int)SignalData[iy+1], InterpolateResult);
		}
		else if (timebase == 2)		// 10ns 
		{
			for(ix=0,iy=start;ix < (GRID_WIDTH + 5);ix+=5,iy++)
			LinearInterpolation(ix, (int)SignalData[iy], ix + 5, (int)SignalData[iy+1], InterpolateResult);
		}
		else if (timebase == 3)		// 20ns 
		{
			for(ix=0,iy=start,incr=2;ix < (GRID_WIDTH + 25);ix+=incr,iy++)
			{
				//toggle increment
				if(incr == 2){incr = 3;}
				else{incr = 2;}

				LinearInterpolation(ix, (int)SignalData[iy], ix + incr, (int)SignalData[iy+1], InterpolateResult);
			}

		}
		else
		{ printf("\r\nUnsupported timebase %d\r\n", timebase); }
	
	}
	else
	{
		int delta,rx;
		
		//printf("Simple interpolation on TB %d\r\n", timebase);

		if (timebase == 0)		// 2ns 
		{
			//for(ix=start,rx=0;rx < ((GRID_WIDTH * 2)-25);ix++,rx+=25)
			for(ix=start,rx=0;rx < (GRID_WIDTH + 25);ix++,rx+=25)
			{
				//copy original value
				InterpolateResult[rx] = SignalData[ix];
	
				//calc the difference between actual and next value
				delta = (SignalData[ix+1] - SignalData[ix]);
				
				//interpolate the next 24 values
				for (int j=1;j <= 24;j++)
				{ InterpolateResult[rx+j] = SignalData[ix] + (delta / ( 25 -j ) ); }
			}
		}
		else if (timebase == 1)		// 5ns 
		{
			//for(ix=start,rx=0;rx < ((GRID_WIDTH * 2)-10);ix++,rx+=10)
			for(ix=start,rx=0;rx < (GRID_WIDTH + 10);ix++,rx+=10)
			{
				//copy original value
				InterpolateResult[rx] = SignalData[ix];
	
				//calc the difference between actual and next value
				delta = (SignalData[ix+1] - SignalData[ix]);
				
				//interpolate the next 9 values
				for (int j=1;j <= 9;j++)
				{ InterpolateResult[rx+j] = SignalData[ix] + (delta / ( 10 -j ) ); }
			}
		}
		else if (timebase == 2)		// 10ns 
		{
			//for(ix=start,rx=0;rx < ((GRID_WIDTH * 2)-5);ix++,rx+=5)
			for(ix=start,rx=0;rx < (GRID_WIDTH + 5);ix++,rx+=5)
			{
				//copy original value
				InterpolateResult[rx] = SignalData[ix];
	
				//calc the difference between actual and next value
				delta = (SignalData[ix+1] - SignalData[ix]);
				
				//interpolate the next 4 values
				for (int j=1;j <= 4;j++)
				{ InterpolateResult[rx+j] = SignalData[ix] + (delta / ( 5 -j ) ); }
			}
	
		}
		else if (timebase == 3)		// 20ns 
		{
			//for(ix=start,rx=0,incr=1;rx < ((GRID_WIDTH * 2)-3);ix++,rx+=(incr+1))
			for(ix=start,rx=0,incr=1;rx < (GRID_WIDTH + 3);ix++,rx+=(incr+1))
			{
				//toggle increment
				if(incr == 1){incr = 2;}
				else{incr = 1;}
	
				//copy original value
				InterpolateResult[rx] = SignalData[ix];
	
				//calc the difference between actual and next value
				delta = (SignalData[ix+1] - SignalData[ix]);
			
				//interpolate the next 1 - 2  values
				for (int j=1;j <= incr;j++)
				{ InterpolateResult[rx+j] = SignalData[ix] + (delta / ( incr + 1 -j ) ); }
			}
		}
		else
		{ printf("\r\nUnsupported timebase %d\r\n", timebase); }

	}
}
//##########################################################################################################################################################
// BF linear interpolation with Bresenham algorithm
void Signal::LinearInterpolation(int x1, int y1, int x2, int y2, unsigned char *interpolation)
{
	
	//--------------------------------------------
	//special case horizontal line
	//--------------------------------------------
	if(y1 == y2)
	{
		if(x1 < x2)
		for(; x1 != x2; x1++)	{ interpolation[x1] = (char)y1; }
		else
		for(; x2 != x1; x2++)	{ interpolation[x2] = (char)y1; }
		return;
	}	

	//--------------------------------------------
	//special case vertical line
	//--------------------------------------------
	else if(x1 == x2)
	{
		if(y1 < y2)
		for(; y1 != y2; y1++)	{ interpolation[x1] = (char)y1; }
		else
		for(; y2 != y1; y2++)	{ interpolation[x1] = (char)y2; }
		return;
	}	

	//-------------------------------------------------------------
	// Bresenham algorithm for drawing diagonal lines
	//-------------------------------------------------------------
	int dy = y2 - y1;
        int dx = x2 - x1;
        int stepx, stepy;

	//check if delta is positive or negative
	if (dy < 0) { dy = -dy;  stepy = -1; } else { stepy = 1; }
        if (dx < 0) { dx = -dx;  stepx = -1; } else { stepx = 1; }

	//special case exact 45 degrees delta x / delta y = 1
	if (dx == dy)
	{
		//horizontal and vertical component increment constant with 1 
		if(x1 < x2) 
		{
			if(y1 < y2)
			{ 
				for(; x1 != x2; x1++, y1++)
				{ interpolation[x1] = (char)y1; }
				return;
			}
			else if(y1 > y2)
			{
				for(; x1 != x2; x1++, y1--)
				{ interpolation[x1] = (char)y1; }
				return;
			}
			
		}
		else if(x1 > x2)
		{
			if(y1 < y2) 
			{
				for(; x1 != x2; x1--, y1++)
				{ interpolation[x1] = (char)y1; }
				return;
			}
			else if(y1 > y2)
			{
				for(; x1 != x2; x1--, y1--)
				{ interpolation[x1] = (char)y1; }
				return;
			}
		}
	}

	
        dy <<= 1;                              		// dy is now 2*dy
        dx <<= 1;                              		// dx is now 2*dx
	
	//set starting point
	interpolation[x1] = (char)y1;
	
	//---------------------------------------------
	//between horizontal and 45 degrees
	//---------------------------------------------
	if (dx > dy)
	{
		int fraction = dy - (dx >> 1);   	// same as 2*dy - dx
		while (x1 != x2) {
			if (fraction >= 0) {
			y1 += stepy;
			fraction -= dx;              	// same as fraction -= 2*dx
			}
			x1 += stepx;
			fraction += dy;          	// same as fraction -= 2*dy
			interpolation[x1] = (char)y1;
		}
        	return;
	}

	//---------------------------------------------
	//between vertical and 45 degrees
	//---------------------------------------------
	if (dx < dy)
	{
		int fraction = dx - (dy >> 1);
		while (y1 != y2) {
			if (fraction >= 0) {
			x1 += stepx;
			fraction -= dy;
			}
			y1 += stepy;
			fraction += dx;
			interpolation[x1] = (char)y1;
		}
		return;
        }

}
//##########################################################################################################################################################
// BF -> generate test signals on all channels
void Signal::TestSignalGenerate(void)
{
	int ix, iy, tog, pw;
	int  lVirtual_Zero = 0;
	char lDCOffset     = 0;

	if (Channel_1_Active)	// draw rectangle signal
	{
		lVirtual_Zero = ADC_ZERO + (int)((float)Virtual_ZeroLevelCH1 / ScaleFactor[Selected_Voltage_CH1][GainIdx]);
		if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
		if (lVirtual_Zero < 0) lVirtual_Zero = 0;
	
		// Signal 1 (Yellow)
		tog = 0;
		iy = lVirtual_Zero + 100;		//Amplitude

		if ( MenuStatus[MENU_CHANNEL1][0] == 8) 	//AC
		lDCOffset = 0;//-20;
		else if ( MenuStatus[MENU_CHANNEL1][0] == 7)	//DC
		lDCOffset = 0;
		else						//GND
		{
			for (ix = 0; (ix < 16384) && !UI_request; ix++)
			SIGNAL1[ix] = lVirtual_Zero;
		}
		
		if ( MenuStatus[MENU_CHANNEL1][0] != 6)
		for (ix = 0, pw = 0; (ix < 16384) && !UI_request; ix++, pw++)
		{	
			//if (ix %200 == 0) 		//Pulswidth
			//if (ix %50 == 0) 		//Pulswidth
			if(pw==50)			//Pulswidth
			{
				pw = 0;
				if (tog == 0) tog = 1;
				else tog = 0;
			}
			
			if (tog == 0)
			{ iy = lVirtual_Zero - 73; }	//Amplitude
			else
			{ iy = lVirtual_Zero + 72;}	//Amplitude
	
			if (iy > 255) iy = 255;	//Limiter
			if (iy < 0) iy = 0;
		
			SIGNAL1[ix] = (char)iy + lDCOffset;
		}	
	
	}

	if (Channel_2_Active)
	{
		lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH2 / ScaleFactor[Selected_Voltage_CH2][GainIdx]);
		if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
		if (lVirtual_Zero < 0) lVirtual_Zero = 0;

		// Signal 2 (Green)
		tog = 0;	
		iy = lVirtual_Zero;
	
		if ( MenuStatus[MENU_CHANNEL2][0] == 8) 	//AC
		lDCOffset = 0;
		else if ( MenuStatus[MENU_CHANNEL2][0] == 7)	//DC
		lDCOffset = 20;
		else						//GND
		{
			for (ix = 0; (ix < 16384) && !UI_request; ix++)
			SIGNAL2[ix] = lVirtual_Zero;
		}

		if ( MenuStatus[MENU_CHANNEL2][0] != 6)
		// calculate sinus signal
		for (ix = 0, iy = 0; (ix < 16384) && !UI_request; ix++, iy+=4)
		{
			if(iy >= 1024)
			iy = 0;

			SIGNAL2[ix] = lVirtual_Zero + (iSin1024[iy] >> 4);
		}
		
/*
		// calculate triangle signal
		for (ix = 0; (ix < 16384) && !UI_request; ix++)
		{
			if (ix %80 == 0)
			{
				if (tog == 0) tog = 1;
				else tog = 0;
			}
			
			if (ix %2 == 0)
			{
				if (tog == 0) iy++;
				else iy--;
			}
			if (iy > 255) iy = 255;	//Limiter
			if (iy < 0) iy = 0;

			SIGNAL2[ix] = (char)iy + lDCOffset;
		}	
*/	
	}

	if (NumberOfChannels == 2)
	return;

	if (Channel_3_Active)
	{
		lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH3 / ScaleFactor[Selected_Voltage_CH3][GainIdx]);
		if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
		if (lVirtual_Zero < 0) lVirtual_Zero = 0;

		// Signal 3 (Purple)
		tog = 0;	
		iy = lVirtual_Zero + 25;
		
		if ( MenuStatus[MENU_CHANNEL3][0] == 8) 	//AC
		lDCOffset = -30;
		else if ( MenuStatus[MENU_CHANNEL3][0] == 7)	//DC
		lDCOffset = 0;
		else						//GND
		{
			for (ix = 0; (ix < 16384) && !UI_request; ix++)
			SIGNAL3[ix] = lVirtual_Zero;
		}

		
		if ( MenuStatus[MENU_CHANNEL3][0] != 6)
		for (ix = 0, pw = 0; (ix < 16384) && !UI_request; ix++,pw++)
		{	
			//if (ix %150 == 0) 		//Pulswidth
			if (pw == 150) 			//Pulswidth
			{
				pw = 0;
				if (tog == 0) tog = 1;
				else tog = 0;
			}
			
			if (tog == 0)
			{ iy = lVirtual_Zero - 25; }	//Amplitude
			else
			{ iy = lVirtual_Zero + 25;}	//Amplitude
	
			if (iy > 255) iy = 255;	//Limiter
			if (iy < 0) iy = 0;
		
			SIGNAL3[ix] = (char)iy + lDCOffset;
		}	
	}

	if (Channel_4_Active)
	{
		lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH4 / ScaleFactor[Selected_Voltage_CH4][GainIdx]);
		if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
		if (lVirtual_Zero < 0) lVirtual_Zero = 0;

		// Signal 4 (Red)
		tog = 0;	
		iy = lVirtual_Zero;
		
		
		if ( MenuStatus[MENU_CHANNEL4][0] == 8) 	//AC
		lDCOffset = 0;
		else if ( MenuStatus[MENU_CHANNEL4][0] == 7)	//DC
		lDCOffset = 25;
		else						//GND
		{
			for (ix = 0; (ix < 16384) && !UI_request; ix++)
			SIGNAL4[ix] = lVirtual_Zero;
		}
	
		if ( MenuStatus[MENU_CHANNEL4][0] != 6)
		for (ix = 0; (ix < 16384) && !UI_request; ix++)
		{
			if (ix %100 == 0)			//period
			{
				if (tog == 0) tog = 1;
				else tog = 0;
			}
			
			if (ix %2 == 0)	 			//Amplitude
			{
				if (tog == 0) iy++;
				else iy--;
			}
			if (iy > 255) iy = 255;	//Limiter
			if (iy < 0) iy = 0;

			SIGNAL4[ix] = (char)iy + lDCOffset;
		}	
	}
	if(FFT_Mode != FFT_OFF)
	FFT_NewData = 1;


}
//##########################################################################################################################################################
//BF for combi-trigger
void Signal::CalcMinMax(int start, int stop, int stepwidth ,unsigned char *SignalData1,  unsigned char *min, unsigned char *max){
  	int lix, lfactor;
	int lbuffer, lvalue1,lvalue2;
	
	*min=255;
	*max=0;

	for (lix = start; lix < stop; lix+=stepwidth)
	{
		//convert to signed integer
		if (SignalData1[lix]>*max)
			*max=SignalData1[lix];
		if (SignalData1[lix]<*min)
			*min=SignalData1[lix];
	}
}
//##########################################################################################################################################################
//BF lookup tables for drawing routines
void Signal::Build_ScaleLookupTable(void)
{

	for (int i=0;i<256;i++)
	{
		ScaleLookupTable[i][0] = (short)((float)(i-ADC_ZERO) * ScaleFactor[0][GainIdx]);	//1er + 2er ranges
		ScaleLookupTable[i][1] = (short)((float)(i-ADC_ZERO) * ScaleFactor[2][GainIdx]);	//5er ranges
	}

}
//##########################################################################################################################################################
//BF FFT lookup table for drawing routines
void Signal::FFT_BuildScaleLookupTable(void)
{
	
	//get scaling index of active channel
	if(MenuStatus[MENU_FFT][0] == 137)	//FFT source channel 1
	{ 
		for (int i=0;i<256;i++)
		{ FFT_ScaleLookupTable[i] = (short)((float)i * ScaleFactor[0][GainIdx] * FFT_ScaleCorrection[Selected_Voltage_CH1][MenuStatus[MENU_FFT][2] - 66]); }
	}
	else if(MenuStatus[MENU_FFT][0] == 138)	//FFT source channel 2
	{ 
		for (int i=0;i<256;i++)
		{ FFT_ScaleLookupTable[i] = (short)((float)i * ScaleFactor[0][GainIdx] * FFT_ScaleCorrection[Selected_Voltage_CH2][MenuStatus[MENU_FFT][2] - 66]); }
	}
	else if(MenuStatus[MENU_FFT][0] == 139)	//FFT source channel 3
	{ 
		for (int i=0;i<256;i++)
		{ FFT_ScaleLookupTable[i] = (short)((float)i * ScaleFactor[0][GainIdx] * FFT_ScaleCorrection[Selected_Voltage_CH3][MenuStatus[MENU_FFT][2] - 66]); }
	}
	else if(MenuStatus[MENU_FFT][0] == 140)	//FFT source channel 4
	{ 
		for (int i=0;i<256;i++)
		{ FFT_ScaleLookupTable[i] = (short)((float)i * ScaleFactor[0][GainIdx] * FFT_ScaleCorrection[Selected_Voltage_CH4][MenuStatus[MENU_FFT][2] - 66]); }
	}



}
//##########################################################################################################################################################
//BF Noise Filter with proprietary algorithm
void Signal::LowPassFilter(int start, int stop, char strength, unsigned char *input, unsigned char *output)
{

	int lmin;					//values to the left side
	int lmax;					//values to the right side
	int lsum;					//totals
	

	// the samples between the undelayed samples are needed so we have to copy the complete signal window to output
	if (MenuStatus[MENU_TIMEBASE][1] == BTN_ON)
	{
		for(int i=start;i < stop ;i++)
		{ output[i] = input[i]; }
	}


	if (strength == 1)	// nearly lossless filtering -> corner frequency at 1GSa/s ca. 80 - 90Mhz
	{
		if (draw_factor < 4)
		{
			lmin = -1;
			lmax =  2;	

			for(int i=start;i < stop ;i+=draw_factor)		// go to next value
			{
				lsum = 0;
				for(int f=lmin;f<=lmax;f++)			// add the values from the left and the right
				lsum += input[i+f];
			
				output[i] = (unsigned char)(lsum>>2);		// calculate average
			}

		}
		else if (draw_factor == 4 || draw_factor == 5)
		{
			lmin = -3;
			lmax = 4;
	
			for(int i=start;i < stop ;i+=draw_factor)		// go to next value
			{
				lsum = 0;
				for(int f=lmin;f<=lmax;f++)			// add the values from the left and the right
				lsum += input[i+f];
				
				output[i] = (unsigned char)(lsum>>3);		// calculate average
			}
		}
		else if (draw_factor >= 10)	
 		{
			lmin = -7;
			lmax = 8;
	
			for(int i=start;i < stop ;i+=draw_factor)		// go to next value
			{
				lsum = 0;
				for(int f=lmin;f<=lmax;f++)			// add the values from the left and the right
				lsum += input[i+f];
				
				output[i] = (unsigned char)(lsum>>4);		// calculate average
			}	
		}
	}
	else if (strength == 2)		// strong filtering with loss of bandwidth -> corner frequency at 1GSa/s ca. 30Mhz
	{

		if (draw_factor < 4)
		{
			lmin = -3;
			lmax =  4;	

			for(int i=start;i < stop ;i+=draw_factor)		// go to next value
			{
				lsum = 0;
				for(int f=lmin;f<=lmax;f++)			// add the values from the left and the right
				lsum += input[i+f];
			
				output[i] = (unsigned char)(lsum>>3);		// calculate average
			}

		}
		else if (draw_factor == 4 || draw_factor == 5)
		{
			lmin = -7;
			lmax = 8;
	
			for(int i=start;i < stop ;i+=draw_factor)		// go to next value
			{
				lsum = 0;
				for(int f=lmin;f<=lmax;f++)			// add the values from the left and the right
				lsum += input[i+f];
				
				output[i] = (unsigned char)(lsum>>4);		// calculate average
			}
		}
		else if (draw_factor >= 10)	
 		{
			lmin = -15;
			lmax = 16;
	
			for(int i=start;i < stop ;i+=draw_factor)		// go to next value
			{
				lsum = 0;
				for(int f=lmin;f<=lmax;f++)			// add the values from the left and the right
				lsum += input[i+f];
				
				output[i] = (unsigned char)(lsum>>5);		// calculate average
			}	
		}


	}


}
//##########################################################################################################################################################
//BF Noise Filter (low pass)	
// IIR algorithm  filterOutput(next) = filterOutput + k * (signal - filterOutput) (k = 0.0....1.0)
//  => y[i+1] = y[i] + (x[i]-y[i])/(2^k)
//
void Signal::IIR_Filter(int start, int stop, char stage, unsigned char *input, unsigned char *output)
{
	
	int lsum;
	int lstart = start -10;

	if(stage == 1)								//corner frequency at 1GSa/s ca. 70Mhz with coefficient 0.5 
	{
		output[lstart] = input[lstart];

		for (int i=lstart;i<stop;i++)
		{ 
			lsum = ((int)input[i] - (int)output[i])>>1;		// using 2 (coefficient 0.25) corner frequency is ca.  30Mhz
			output[i+1] = (unsigned char)((int)output[i] + lsum);	
		}
	}


	if(stage == 2)								//corner frequency at 1GSa/s ca. 35 - 40Mhz with coefficients 0.5 
	{
		CopyBuffer[lstart] = input[lstart];

		for (int i=lstart;i<stop;i++)
		{ 
			lsum = ((int)input[i] - (int)CopyBuffer[i])>>1;	
			CopyBuffer[i+1] = (unsigned char)((int)CopyBuffer[i] + lsum);	
		}

		output[lstart] = CopyBuffer[lstart];

		for (int i=lstart;i<stop;i++)
		{ 
			lsum = ((int)CopyBuffer[i] - (int)output[i])>>1;	
			output[i+1] = (unsigned char)((int)output[i] + lsum);	
		}

	}


	if(stage == 3)								//corner frequency at 1GSa/s ca. 20Mhz with coefficients 0.5 and 0.25 in the last stage
	{
		for (int i=lstart;i<stop;i++)
		{ 
			output[lstart] = input[lstart];

			lsum = ((int)input[i] - (int)output[i])>>1;	
			output[i+1] = (unsigned char)((int)output[i] + lsum);	
		}

		CopyBuffer[lstart] = output[lstart];

		for (int i=lstart;i<stop;i++)
		{ 
			lsum = ((int)output[i] - (int)CopyBuffer[i])>>1;	
			CopyBuffer[i+1] = (unsigned char)((int)CopyBuffer[i] + lsum);	
		}

		output[lstart] = CopyBuffer[lstart];

		for (int i=lstart;i<stop;i++)
		{ 
			lsum = ((int)CopyBuffer[i] - (int)output[i])>>2;	
			output[i+1] = (unsigned char)((int)output[i] + lsum);	
		}

	}


}
//##########################################################################################################################################################
/*
//BF average
void Signal::Average(int start, int stop, unsigned char mode, unsigned char *input, unsigned char *avrg_buffer)
{




}
*/
//##########################################################################################################################################################






